
extern void print(char *ptr);
extern void itoa(unsigned long n, char *s);

#include "mpc555.h"
#include "tpu_fqd.h"
#include "mpc500_util.h"

int main() {

     struct TPU3_tag *tpua = &TPU_A;   /* pointer for TPU routines */
     unsigned long delaycount;
     signed short currtimestamp, lastedgetime, pin1status, pin2status;
     char str[50];

    /* Initialize quadrature input function with:   */
    /*    -Input signal on TPU A channel 1 and 2    */
    /*     (note: you just supply the lower
                  (which is primary) channel)       */
    /*    -Inital count value of $0000              */
    /*    -Schedule as high priority in the TPU     */
    tpu_fqd_init( tpua,1 , TPU_PRIORITY_HIGH, 0x0000);
    
    while (1) {
	tpu_fqd_data(tpua,1,&currtimestamp,&lastedgetime,&pin1status,&pin2status);
	print("\n");
	print("Current timestamp: ");
	itoa(currtimestamp,str);
	print(str);
	print("\n");
	print("Last edge timestamp: ");
	itoa(lastedgetime,str);
	print(str);
	print("\n");
	print("Pin 1 status: ");
	print((pin1status & TPU_FQD_PIN_HIGH) ? "HIGH" : "LOW");
//	print((pin1status == TPU_FQD_PIN_HIGH) ? "HIGH" : "LOW");
//	itoa(pin1status,str);
//	itoa(pin1status,str);
//	print(str);
	print("\n");
	print("Pin 2 status: ");
	print((pin2status & TPU_FQD_PIN_HIGH) ? "HIGH" : "LOW");
//	print((pin2status == TPU_FQD_PIN_HIGH) ? "HIGH" : "LOW");
//	itoa(pin2status,str);
//	print(str);
	print("\n");

        delaycount=0;
        do{
                delaycount++;
        }while(delaycount < 500000);
    }
}


